//name of file: core.cpp
#define DEBUG_CORE


inline void calculate_signs(CVertex* vertex,
  CVertex V,DListElement<CEdge*>* current,
  short int& leftsign, short int& rightsign){

  K2 testedge,leftline,rightline;

  testedge  = vertex[current->edgep->foot]            - V;
  leftline  = vertex[current->previous->edgep->foot]  - V;
  rightline = vertex[current->next->edgep->foot]      - V;
  leftsign  = sgn(Det(leftline ,testedge));
  rightsign = sgn(Det(rightline,testedge));
}//claculate_signs

//ATTENTION:
//the names of fuction-parameters are not conform to the file
//triangulate.cpp !
//start corresponds to current
//leftmost corresponds to leftmost
//rightmost corresponds to rightmost

void findExtremeVertices(CVertex* vertex, CVertex V,
     DListElement<CEdge*>* start, DListElement<CEdge*>* &leftmost,
     DListElement<CEdge*>* &rightmost){

     K2 testedge, leftline, rightline;
     K2 refline, Vline, tovertex, tonext, toprevious;

     DListElement<CEdge*> *current = start;
     DListElement<CEdge*> *end1,*end2,*temp;
     DListElement<CEdge*> *extreme1, *extreme2;

     short int leftsign, rightsign;
     short int sigl,sigr,sigV;

     #ifdef DEBUG_CORE
     cout<< "enter function findExtremeVertices"<< endl;
     #endif

     do{
       #ifdef DEBUG_CORE
       cout<<"current   "<<*(current->edgep);
       #endif
       testedge  = vertex[current->edgep->foot]            - V;
       leftline  = vertex[current->previous->edgep->foot]  - V;
       rightline = vertex[current->next->edgep->foot]      - V;
       leftsign  = sgn(Det(leftline ,testedge));
       rightsign = sgn(Det(rightline,testedge));

       if(rightsign!=0 && leftsign!=0){
         if(leftsign == rightsign)
           {extreme1 = current; current = start->previous; break;}
         else current = current->next;
       }

       else if(rightsign==0 && leftsign!=0){
         end1 = current;
         while(rightsign==0){
           current = current->next;
           calculate_signs(vertex,V,current,leftsign,rightsign);
         }
         end2 = current;
         if(Norm(vertex[end1->edgep->foot]-V) < Norm(vertex[end2->edgep->foot]-V))
           extreme1 = end1; else extreme1 = end2;
         current= start->previous;
         #ifdef DEBUG_CORE
         cout<<"end1      "<<*(end1->edgep);
         cout<<"end2      "<<*(end2->edgep);
         #endif
         break;
       }

       else if(rightsign!=0 && leftsign==0){
         end1 = current;
         while(leftsign==0){
           current = current->previous;
           calculate_signs(vertex,V,current,leftsign,rightsign);
         }
         end2=current;
         if(Norm(vertex[end1->edgep->foot]-V) < Norm(vertex[end2->edgep->foot]-V))
           extreme1 = end1; else extreme1 = end2;
         current= current->previous;
         #ifdef DEBUG_CORE
         cout<<"end1      "<<*(end1->edgep);
         cout<<"end2      "<<*(end2->edgep);
         #endif
         break;
       }

       else if(rightsign==0 && leftsign==0){
         #ifdef DEBUG_CORE
         cout << "test"<<endl;
         #endif
         temp = current;
         while(rightsign==0){
           current = current->next;
           calculate_signs(vertex,V,current,leftsign,rightsign);
         }
         end1=current;
         current = temp;
         leftsign=0;
         while(leftsign==0){
           current = current->previous;
           calculate_signs(vertex,V,current,leftsign,rightsign);
         }
         end2=current;
         if(Norm(vertex[end1->edgep->foot]-V) < Norm(vertex[end2->edgep->foot]-V))
           extreme1 = end1; else extreme1 = end2;
         current= current->previous;
         #ifdef DEBUG_CORE
         cout<<"end1      "<<*(end1->edgep);
         cout<<"end2      "<<*(end2->edgep);
         #endif
         break;
       }

       else{ cerr<<"Error: Can't leave the while loop"<< endl; exit(1);}
     }while(1);
     #ifdef DEBUG_CORE
     cout<<"extreme1  "<< *(extreme1->edgep);
     #endif
     do{
       #ifdef DEBUG_CORE
       cout<<"current   "<<*(current->edgep);
       #endif
       testedge  = vertex[current->edgep->foot]            - V;
       leftline  = vertex[current->previous->edgep->foot]  - V;
       rightline = vertex[current->next->edgep->foot]      - V;
       leftsign  = sgn(Det(leftline ,testedge));
       rightsign = sgn(Det(rightline,testedge));

       if(rightsign!=0 && leftsign!=0){
         if(leftsign == rightsign){extreme2 = current; break;}
         else current = current->previous;
       }

       else if(rightsign==0 || leftsign!=0){
       }

       else if(rightsign!=0 || leftsign==0){
         end1=current;
         while(leftsign==0){
           current = current ->previous;
           calculate_signs(vertex,V,current,leftsign,rightsign);
         }
         end2=current;
         if(Norm(vertex[end1->edgep->foot]-V) < Norm(vertex[end2->edgep->foot]-V))
           extreme2 = end1; else extreme2 = end2;
         #ifdef DEBUG_CORE
         cout<<"end1      "<<*(end1->edgep);
         cout<<"end2      "<<*(end2->edgep);
         #endif
         break;
       }
       else{ cerr<<"Error: Can't leave the while loop"<< endl; exit(1);}
     }while(1);



     #ifdef DEBUG_CORE
     cout<<"extreme2  "<< *(extreme2->edgep);
     #endif
     refline   = vertex[extreme2->edgep->foot]           - vertex[extreme1->edgep->foot];
     rightline = vertex[extreme1->next->edgep->foot]     - vertex[extreme1->edgep->foot];
     leftline  = vertex[extreme1->previous->edgep->foot] - vertex[extreme1->edgep->foot];
     Vline     = V - vertex[extreme1->edgep->foot];

     #ifdef DEBUG_CORE
     cout<<"refline   "<<refline <<endl;
     cout<<"leftline  "<<leftline<<endl;
     cout<<"rightline "<<rightline<<endl;
     cout<<"Vline     "<<Vline<<endl;
     #endif

     sigr = sgn(Det(rightline,refline));
     sigl = sgn(Det(leftline ,refline));
     sigV = sgn(Det(Vline,refline));

     if(sigr!=0 && sigl!=0){

       #ifdef DEBUG_CORE
       cout<<"sigr neq sigl "<<endl;
       cout<<"sigl "<<sigl<<endl;
       cout<<"sigr "<<sigr<<endl;
       cout<<"sigV "<<sigV<<endl;
       #endif

       if(sigr == sigV){leftmost = extreme1 ; rightmost = extreme2;}
       if(sigl == sigV){leftmost = extreme2 ; rightmost = extreme1;}
     }
     if(sigr==0)//{leftmost = extreme1; rightmost = extreme2;}
     { if(sigl==sigV){leftmost=extreme2; rightmost=extreme1;}
       if(sigl!=sigV){leftmost=extreme1; rightmost=extreme2;}
     }
     if(sigl==0) //{leftmost = extreme2; rightmost = extreme1;}
     { if(sigr==sigV){leftmost=extreme1; rightmost=extreme2;}
       if(sigr!=sigV){leftmost=extreme2; rightmost=extreme1;}
     }
     #ifdef DEBUG_CORE
     cout << "leftmost  " << *(leftmost->edgep);
     cout << "rightmost " << *(rightmost->edgep);
     cout << "have left function findExtremeVertices" << endl<< endl;
     #endif
}//findExtremeVertices
