//name of file: graphics.cpp
#include"rgraph.h"

//colors
#define BLACK   1
#define RED     2
#define YELLOW  3
#define GREEN   4
#define CYAN    5
#define BLUE    6
#define LILA    7

#include<sstream>  //13.04.05


void welcome_window(){
 rmoveto(-0.5,0.8);
 plotstring("2D - MESH-GENERATOR - GENERATEUR de MAILLAGE");
 rmoveto(-0.9,0.6);
 plotstring("c 2000, ecrit par  M.Rheinlander & J.Rivera  -- soumis comme projet final");
 rmoveto(-0.9,0.5);
 plotstring("pour le cours 'C++ et elements finis' du DEA Analyse Numerique, Paris VI");
 rmoveto(-0.9,0.4);
 plotstring("Merci a Prof. Hecht pour son conseil !");
 rmoveto(-0.9,0.3);
 plotstring("Ce logiciel utilise Xrgraph comme interface de graphique.");
 rmoveto(-0.4,0.0);
 plotstring("Appuyez sur une touche pour continuer / press a key to continue.");
 rmoveto(-0.7,-0.1);
 plotstring("Instructions are given in the X-Terminal");
 rattente(1000);
 reffecran();
};


void MarkPoint(float x,float y, char* c=""){
   float l=0.002;
   int oldcolor = LaCouleur();

   couleur(RED);
   rmoveto(x+2*l,y+2*l);
   plotstring(c);
   rmoveto(x - l,y - l);
   rlineto(x + l,y + l);
   rmoveto(x - l,y + l);
   rlineto(x + l,y - l);
   couleur(oldcolor);
}

void MarkPointNumber(float x, float y, int index){
   float l=0.002;
   //ostrstream number;                  13.04.05
   //number << index << ends;
   int oldcolor = LaCouleur();

   couleur(RED);
   rmoveto(x+2*l,y+2*l);
   //plotstring(number.str());          13.04.05
   rmoveto(x - l,y - l);
   rlineto(x + l,y + l);
   rmoveto(x - l,y + l);
   rlineto(x + l,y - l);
   couleur(oldcolor);
}




void input_boundaries(CVertex *&vertex,int &vnum,CBoundary *&bound,int& bnum,char* filename){
  float x,y,oldx,oldy,startx,starty;
  char c;
  int vcounter =0;
  int bcounter =0;
  ofstream fout(filename,ios::out);
  fout.setf(ios::right | ios::showpos | ios::fixed); fout.precision(4);
  cout.setf(ios::right | ios::showpos | ios::fixed); cout.precision(4);


  //initialisation
  vertex = (CVertex* ) calloc(sizeof(CVertex),1);
  bound  = (CBoundary* ) calloc(sizeof(CBoundary),1);

  cout<<"\nDo you want to enter boundary-polygons ? (Y/N)"<<endl;
  do{c=Getxyc(x,y);} while(c!='n' && c!='y');
  if(c=='y'){
    cout<<"\nINSTRUCTION for data-input:"<<endl;
    cout<<"Enter by mouse-click (left key) the vertices of the boundary-polygon. "<<endl;
    cout<<"Avoid to click twice on the same spot, this will cause a runtime error !"<<endl;
    cout<<"Of course, each boundary-polygon should contain at least three vertices."<<endl;
    cout<<"In the same way it is clear that the boundary-polygons must not dissect each other."<<endl;
    cout<<"To get a reasonable triangulation it is IMPORTANT, to trace every boundary in the"<<endl;
    cout<<"counterclockwise i.e. positive mathematical sense, starting with the outer boundary."<<endl;
    cout<<"Possible further boundaries confinig interior holes are traced thereafter."<<endl;
    cout<<"The domain is therefore on the left hand side of the such orientated outer boundary,"<<endl;
    cout<<"whereas it stretches to the right hand side of the inner boundaries."<<endl;
    cout<<"For stopping press 'E'."<<endl;
    cout<<"The last vertex is then automaticly connected to the first vertex."<<endl;
    do{
      //setting the first vertex of the boundary-polygon
      cout<<"\nEnter now the vertices of the boundary-polygon :"<<endl;
      fout<<"\n//Vertices_of_boundary-polygon"<<endl<<endl;
      do{c=Getxyc(x,y);} while(c!='e' && int(c) != -5);
      MarkPoint(x,y);
      oldx=x; oldy=y;
      startx=x; starty=y;
      vertex = (CVertex*)   realloc(vertex, sizeof(CVertex  )*(vcounter+1));
      bound  = (CBoundary*) realloc(bound , sizeof(CBoundary)*(bcounter+1));
      bound[bcounter].first = vcounter;
      vertex[vcounter][1]=x; vertex[vcounter][2]=y; vertex[vcounter].bflag = bcounter;
      cout.width(3) ; cout << vcounter;
      cout.width(10); cout << x;
      cout.width(10); cout << y<<endl;
      fout.width(3) ; fout << vcounter;
      fout.width(10); fout << x;
      fout.width(10); fout << y<<endl;
      vcounter++;
      //setting further vertices of the boundary-polygon
      //while((c=Getxyc(x,y)) != 'e'){
      while(1){
        do{ c=Getxyc(x,y);}while(c!='e' && int(c) != -5);
        if(c=='e') break;
        MarkPoint(x,y); couleur(GREEN);
        rmoveto(oldx,oldy); rlineto(x,y); oldx=x; oldy=y;
        vertex = (CVertex*) realloc(vertex, sizeof(CVertex)*(vcounter+1));
        vertex[vcounter][1]=x; vertex[vcounter][2]=y; vertex[vcounter].bflag = bcounter;
        cout.width(3) ; cout << vcounter;
        cout.width(10); cout << x;
        cout.width(10); cout << y<<endl;
        fout.width(3) ; fout << vcounter;
        fout.width(10); fout << x;
        fout.width(10); fout << y<<endl;
        //cout<<"Getxyc "<<int(c)<<endl;
        vcounter++;
      }//while
      rmoveto(startx,starty); rlineto(oldx,oldy);
      bound[bcounter].last = vcounter-1;
      bcounter++;
      cout<<"\nDo you want to enter another boundary-polygon ? (Y/N)"<<endl;
      do{c=Getxyc(x,y);} while(c!='y' && c!='n');
    }while(c=='y'); //do-while
  } //if

  cout<<"\nDo you want to enter any other vertices ? (Y/N)"<<endl;
  fout<<"\n//Other_vertices"<<endl<<endl;
  do{c=Getxyc(x,y);} while(c!='y' && c!='n');
  if(c=='y'){
    cout<<"\nEnter now by mouse-click (left key) the vertices after having read the following indication: "<<endl;
    cout<<"To get a reasonable list of generated triangles, place the vertices only inside"<<endl;
    cout<<"the domain to be triangulated. It might be reasonable to place also some points in"<<endl;
    cout<<"interior holes, if the 'hole' is considered as a special part of the domain."<<endl;
    cout<<"However this option is not yet available."<<endl;
    cout<<"If you haven't entered any boundaries, the program will just calculate the Delaunay"<<endl;
    cout<<"triangulation of the convex hull generated by the entered vertices."<<endl;
    cout<<"Avoid to click on a spot being already marked, this will trigger a runtime error."<<endl;
    cout<<"To finish the input press 'E'."<<endl;
    //while(c=Getxyc(x,y) != 'e'){
    while(1){
      do{ c=Getxyc(x,y);}while(c!='e' && int(c) != -5);
      if(c=='e') break;
      MarkPoint(x,y);
      vertex = (CVertex*) realloc(vertex, sizeof(CVertex)*(vcounter+1));
      vertex[vcounter][1]=x; vertex[vcounter][2]=y;  vertex[vcounter].bflag = -1;
      cout.width(3) ; cout << vcounter;
      cout.width(10); cout << x;
      cout.width(10); cout << y<<endl;
      fout.width(3) ; fout << vcounter;
      fout.width(10); fout << x;
      fout.width(10); fout << y<<endl;
      vcounter++;
    }; //while
  }//if
  cout<<"\nInput finished !"<<endl;
  vnum = vcounter;
  bnum = bcounter;
}//function input_boundaries




void plot_data(CVertex* vertex, int vnum, CBoundary* bound, int bnum,int color=RED){
  int i,j;
  char c;
  float x,y;
  couleur(color);
  for(i=0; i<bnum; i++){
    //cout<<"i "<<i<<endl;
    for(j=bound[i].first; j< bound[i].last; j++){
      //cout<<vertex[j]<<endl;
      MarkPoint(vertex[j][1],vertex[j][2]);
      rmoveto(vertex[j][1],   vertex[j][2]  );
      rlineto(vertex[j+1][1], vertex[j+1][2]);
      //do{c=Getxyc(x,y);}while(c!='w');
    }
    //cout<<j+1<<endl;
    MarkPoint(vertex[bound[i].last][1],vertex[bound[i].last ][2]);
    rmoveto(vertex[bound[i].last ][1], vertex[bound[i].last ][2]);
    rlineto(vertex[bound[i].first][1], vertex[bound[i].first][2]);
    //do{c=Getxyc(x,y);}while(c!='w');
  }
 //rattente(1000);
}//function plot_data




//////////////////////////////////////////////////////////////////////////


void plot_edges(CVertex* vertex, int vnum, CEdge* edge, int ednum,bool numeration){
  //ostrstream number[vnum];   // 13.04.05
  //ostringstream number[vnum];
  //initgraphique();
  //cadreortho(-1,1,-1,1);
  //showgraphic();
  //reffecran();
  couleur(1);
  for(int i=0; i<ednum; i++){
    rmoveto(vertex[edge[i].foot][1], vertex[edge[i].foot][2]);
    rlineto(vertex[edge[i].head][1], vertex[edge[i].head][2]);
  }
  for(int i=0; i<vnum; i++){
    //number[i] << i << ends;    13.04.05
    //if(numeration == TRUE)
    //  MarkPoint(vertex[i][1],vertex[i][2], number[i].str());
    //else
    //  MarkPoint(vertex[i][1],vertex[i][2]);
  }
  rattente(1000);
  //closegraphique();
}

void plot_vertexnumber(CVertex* vertex, int index){
  //ostrstream number;  // 13.04.05
  //number << index << ends;
  //MarkPoint(vertex[index][1],vertex[index][2], number.str());
  cout<< index<<endl;
}



void plot_edge(CVertex* &vertex,CEdge* &edge, int num,int color=BLACK){
  couleur(color);
  rmoveto(vertex[edge[num].foot][1], vertex[edge[num].foot][2]);
  rlineto(vertex[edge[num].head][1], vertex[edge[num].head][2]);
  //rattente(1000);
}


void plot_edge_color(CVertex* &vertex,CEdge edge, int color){
  couleur(color);
  rmoveto(vertex[edge.foot][1], vertex[edge.foot][2]);
  rlineto(vertex[edge.head][1], vertex[edge.head][2]);
}



void fill_triangle(CVertex* &vertex,int v1, int v2, int v3, int color){
   float coordinates[6];
   coordinates[0] = vertex[v1][1];
   coordinates[1] = vertex[v1][2];
   coordinates[2] = vertex[v2][1];
   coordinates[3] = vertex[v2][2];
   coordinates[4] = vertex[v3][1];
   coordinates[5] = vertex[v3][2];
   couleur(color);
   fillpoly(3,coordinates);
}




