//name of file: main.cppp

#include"classes.cpp"
#include"graphics.cpp"
#include"triangulate.cpp"
#include"point5.cpp"
#include"point6.cpp"

int main(int argc,char *argv[]){
  int  vnum;  //number of vertices
  int  bnum;  //number of boundaries
  int ednum;  //number of edges
  //int  tnum;  //number of triangles  is not used as function parameter
  int *perm;  //permutation: gives new index perm[i] as function of old index i

  //data constructions used for building and saving a triangulation
  CVertex     *vertex;
  CBoundary    *bound;
  CEdge         *edge;
  CTriangle *triangle;

  cout<<"\nWelcome to meshgen !"<<endl;
  cout<<"Note, that for every kind of input the graphic window must be activated."<<endl;

  initgraphique();
  showgraphic();
  cadreortho(0,0,1);
  welcome_window();


  if(argc==1)
    input_boundaries(vertex,vnum,bound,bnum,"vertices.dat");
  else if(argc==2){
    //read_vertices (vertex,vnum,bound,bnum,argv[1]);   13.04.05
    //plot_data(vertex,vnum,bound,bnum,RED);
  }
  else{cerr<<"Error: inadmissible number of arguments !"<<endl; exit(1);}

  cout<<"Press a key to continue !"<<endl; rattente(1000);

  //constructing a Delaunay triangulation of the convex hull
  perm = sort_vertices(vertex,vnum);
  edge = triangulate(vertex,vnum,ednum);

  //forcing the boundary edges
  for(int i=0; i<bnum; i++){
    for(int j=bound[i].first; j<bound[i].last; j++)
      forcing(vertex,edge,ednum,perm[j],perm[j+1]);
    forcing(vertex,edge,ednum,perm[bound[i].last],perm[bound[i].first]);
  }

  //selecting the edges being inside the domain or belonging to its boundary
  assign_edges_to_vertices(vertex,vnum,edge,ednum);
  select_edges(vertex,bound,bnum,perm);

  //saving the triangulation
  triangle = ascertain_triangles(vertex,vnum,edge,ednum,bound,bnum);
  cout<<"\nVertices, triangles and boundary edges are saved in the file 'mesh.dat'."<<endl;

  cout<<"\nYou have now four options to display the triangulation, you can change between them"<<endl;
  cout<<"by pressing one of the number keys:"<<endl;
  cout<<"Press 1 to display the triangulated domain WITHOUT numbering of vertices."<<endl;
  cout<<"Press 2 to display the triangulated domain WITH numbering of vertices."<<endl;
  cout<<"Press 3 to display the triangulated convex hull WITHOUT numbering of vertices."<<endl;
  cout<<"Press 4 to display the triangulated convex hull WITH numbering of vertices."<<endl;
  cout<<"Press Q to quit the program !"<<endl;

  while(1){
    float x,y;
    char c;
    c = Getxyc(x,y);
    //domain without numbering
    if(c=='1'){
      reffecran();
      for(int i=0; i<ednum; i++){
        if(edge[i].bflag == TRUE)
          plot_edge(vertex,edge,i,BLACK);
        else if(edge[i].bflag == FALSE && edge[i].cflag == 0)
          plot_edge(vertex,edge,i,BLUE);
      }//for
    }//if
    //domain with numbering
    if(c=='2'){
      reffecran();
      for(int i=0; i<ednum; i++){
        if(edge[i].bflag == TRUE)
          plot_edge(vertex,edge,i,BLACK);
        else if(edge[i].bflag == FALSE && edge[i].cflag == 0)
          plot_edge(vertex,edge,i,BLUE);
       }//for
       for(int i=0; i<vnum; i++)
         MarkPointNumber(vertex[i][1],vertex[i][2],i);
    }//if
    //convex hull without numbering
    if(c=='3'){
      reffecran();
      for(int i=0; i<ednum; i++)
        plot_edge(vertex,edge,i,BLACK);
      for(int i=0; i<vnum; i++)
        MarkPoint(vertex[i][1],vertex[i][2]);
    }//if
    //convex hull with numbering
    if(c=='4'){
      reffecran();
      for(int i=0; i<ednum; i++)
        plot_edge(vertex,edge,i,BLACK);
      for(int i=0; i<vnum; i++)
        MarkPointNumber(vertex[i][1],vertex[i][2],i);
    }//if
    //quit
    if(c=='q') break;
  }//while

  closegraphique();
  return 1;
}
