//#define DEBUG_SELECT

void flood(CEdge* startedge, int cvalue){
  Queue<CEdge*> queue;
  CEdge* current = startedge;

  #ifdef DEBUG_SELECT
  cout<<"this is function flood "<<endl;
  #endif

  if(current==NULL) return;
  queue.push(current);

  #ifdef DEBUG_SELECT
  cout<<"queue.cardinal() "<<queue.cardinal()<<endl;
  #endif

  do{
    current = queue.pop();
    #ifdef DEBUG_SELECT
    cout<<"current "<<(*current);
    #endif
    current->cflag = cvalue;
    if(current->fln->bflag == FALSE && current->fln->cflag == -1)
      queue.push(current->fln);
    if(current->frn->bflag == FALSE && current->frn->cflag == -1)
      queue.push(current->frn);
    if(current->hln->bflag == FALSE && current->hln->cflag == -1)
      queue.push(current->hln);
    if(current->hrn->bflag == FALSE && current->hrn->cflag == -1)
      queue.push(current->hrn);
    #ifdef DEBUG_SELECT
    cout<<"queue.cardinal() = "<< queue.cardinal() <<endl;
    rattente(1000);
    #endif
  }while(queue.cardinal()!=0);
}// flood


CEdge*** prepare_boundaries(CVertex* vertex, CBoundary* bound, int bnum, int* perm){
  CEdge*** bline;  //array of array of pointer to CEdge

  bline = new (CEdge**)[bnum];
  for(int i=0; i<bnum; i++){
    bline[i] = new (CEdge*)[bound[i].last - bound[i].first +1];
  }

  for(int i=0; i<bnum; i++){
    int s=bound[i].first;
    int n=bound[i].last - bound[i].first+1;
    for(int j=0; j<n; j++){
      for(int k=0; k<vertex[perm[s+j]].ne; k++){
        if     (vertex[perm[s+j]].e[k]->foot == perm[s+(j+1)%n]){
          bline[i][j] = vertex[perm[s+j]].e[k];
          bline[i][j]->reverse();
          bline[i][j]->bflag = TRUE;
          bline[i][j]->cflag = i;
          #ifdef DEBUG_SELECT
          plot_edge_color(vertex,*(bline[i][j]),GREEN);
          #endif
          break;
        }//if
        else if(vertex[perm[s+j]].e[k]->head == perm[s+(j+1)%n]){
          bline[i][j] = vertex[perm[s+j]].e[k];
          bline[i][j]->bflag = TRUE;
          bline[i][j]->cflag = i;
          #ifdef DEBUG_SELECT
          plot_edge_color(vertex,*(bline[i][j]),GREEN);
          #endif
          break;
        }//else if
      }// for k
    }// for j
  }//for i

  return bline;
}//prepare_boundaries


CEdge* find_startedge(CEdge*** bline,CBoundary* bound,int bindex){
  int n=bound[bindex].last - bound[bindex].first +1;
  for(int i=0; i<n; i++){
    if(bline[bindex][i]->fln->bflag != TRUE)
      return bline[bindex][i]->fln;
  }
  return NULL;
}//find_startedge


void select_edges(CVertex* vertex,CBoundary* bound,int bnum,int *perm){
  CEdge*** bline;
  CEdge* startedge;
  bline = prepare_boundaries(vertex,bound,bnum,perm);
  for(int i=0; i<bnum; i++){
    startedge = find_startedge(bline,bound,i);
    flood(startedge,i);
  }
}//select_edges
