//name of file: triangulate.cpp

#define GRAPHIC
//#define DEBUG
#define DELAUNAY


#include"core.cpp"   //contains the function findExtremeVertices


/*   13.04.05
void read_vertices(CVertex* &vertex, int &vnum,CBoundary* &bound,int &bnum,char* filename){
 fstream fin(filename,ios::in);
 if(!fin){cerr<<"Error: Can not open "<<filename<<endl; exit(1);}
 cout<<"Try to read the file "<<filename<<"  ..."<<endl<<endl;
 cout<<"If the data-reading should not be terminated within a few seconds,"<<endl;
 cout<<"the file might be corrupted.In case of such a crash press CTRL+C to abort !"<<endl<<endl;
 //filestream ref is used for comparing  current position
 //of file pointer with file end
 fstream ref(filename,ios::in);
 ref.seekp(0,ios::end);
 char c;
 float x,y;
 int bflag = 0;   //bflag for vertices
 int bcounter =0;
 int vcounter =0;
 char string[40];

 bound  = (CBoundary*) calloc(sizeof(CBoundary),1);
 vertex = (CVertex*)   calloc(sizeof(CVertex),1);

 fin >> string;
 //cout<<string<<endl;
 if(string[2]=='V'){
   bound = (CBoundary*) realloc(bound,sizeof(CBoundary)*(bcounter+1));
   bound[bcounter].first = vcounter;
 }
 while(fin.tellp()!=ref.tellp()-1){
   fin >> string; //cout<<string<<"  ";
   if(string[2]=='V'){
     bound[bcounter].last = vcounter-1;
     bcounter++;
     bflag = bcounter;
     //cout<<endl;
     fin >> string; //cout<<string<<"  ";
     bound = (CBoundary*) realloc(bound,sizeof(CBoundary)*(bcounter+1));
     bound[bcounter].first = vcounter;
   }
   else if(string[2]=='O'){
     bound[bcounter].last = vcounter-1;
     bcounter++;
     bflag = -1;
     //cout<<endl;
     fin >> string; //cout<<string<<"  ";
     if(vcounter != (float) atof(string)) break;
   }
   vertex = (CVertex*) realloc(vertex,sizeof(CVertex)*(vcounter+1));
   fin >> string;
   vertex[vcounter][1] = (float) atof(string);
   //cout<<string<<"  ";
   fin >> string;
   vertex[vcounter][2] = (float) atof(string);
   //cout<<string<<endl;
   vertex[vcounter].bflag = bflag;
   vcounter++;
 }
 vnum=vcounter;
 bnum=bcounter;
 cout<<"Data-reading finished !"<<endl;
}//read_vertices
*/
////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////

int* sort_vertices(CVertex* &vertex, int vnum){
  int shortest = 0;
  K2 translation;
  K dist = Norm(vertex[0]);
  int* perm;

  for(int i=1; i<vnum; i++)
  if(Norm(vertex[i])< dist){
    shortest = i;
    dist = Norm(vertex[shortest]);
  }
  translation = vertex[shortest];
  for(int i=0; i<vnum; i++) vertex[i]-= translation;
  //for(int i=0; i<vnum; i++) vertex[i] = vertex[i] - translation;
  perm = select_sort(vertex,vnum);
  for(int i=0; i<vnum; i++) vertex[i]+= translation;
  //for(int i=0; i<vnum; i++) vertex[i] = vertex[i] + translation;
  return perm;
}//function sort_vertices

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

//we suppose that the angles at pa and pb are lesser than pi
//so we check only the angles at p1 and p2
bool convex_quadrangle(CVertex pa,CVertex pb,CVertex p1,CVertex p2){
  int sign1,sign2;
  
  sign1 = sgn(Det(pb-p1,pa-p1));
  sign2 = sgn(Det(pb-p1,p2-p1));
  if(sign1 == 0) return FALSE;
  if(sign1 != sign2) return FALSE;
  else{
    sign1 = sgn(Det(pa-p2,pb-p2));
    sign2 = sgn(Det(pa-p2,p1-p2));
    if(sign1 == 0) return FALSE; 
    if(sign1 == sign2) return TRUE;
    if(sign1 != sign2) return FALSE; 
  }
}//function convex_quadrangle

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

bool delaunay(CVertex *vertex, CEdge* ref){
  char c=' ';
  float x,y;
  float leftside,rightside;
  CVertex pa,pb,p1,p2;
  CEdge* diag;
  diag = ref->fln;
  if(diag->status == EXTERN){
    #ifdef DEBUG
    cout <<"diag: " << *diag;
    cout<<"edge can't be changed as it belongs to the boundary" <<endl;
    cout<<"press a key"<<endl;
    rattente(1000);
    #endif
    return TRUE;
  }
  else{
    pa = vertex[diag->left];
    pb = vertex[diag->right];
    p1 = vertex[diag->foot];
    p2 = vertex[diag->head];
    #ifdef DEBUG
    cout <<"diag: " << *diag;
    cout <<"considered quadrangle: " <<diag->left <<" "<<diag->right<<" "<<diag->foot<<" "<<diag->head <<endl;
    #endif
    if(convex_quadrangle(pa,pb,p1,p2)==FALSE){
      #ifdef DEBUG
      cout<<"quadrangle is not convex !"<<endl;
      cout<<"so there is everything all right !"<<endl << endl;
      #endif

      return TRUE;
    }
    else{
      #ifdef DEBUG
      cout<<"quadrangle is convex" << endl;
      cout<<"edge to be changed: " << *(ref->fln);
      #endif
      leftside = Det(p2-p1,pb-p1)*((p2-pa)*(pb-pa));
      rightside = Det(p2-pa,pb-pa)*((p2-p1)*(pb-p1));
      if(leftside <= rightside){
        #ifdef DEBUG
        cout<<"you shouldn't change the edge"<<endl;
        #endif
        c='n';
      }
      else{
        #ifdef DEBUG
        cout<<"you should change the edge"<<endl;
        #endif
        c='y';
      }
      #ifdef DEBUG_DELAUNAY
      cout<<"press 'y' to change, 'n' to continue without changing"<<endl;
      do{
        c=Getxyc(x,y);
      }while(c!='y' && c!='n');
      #endif
      if(c=='y'){
        #ifdef DEBUG
        cout<<"edge will be changed !"<<endl;
        #endif
        return FALSE;
      }
      else{
        #ifdef DEBUG
        cout<<"edge will not be changed !"<<endl<<endl;
        #endif
        return TRUE;
      }//else
    }//else
  }//else
}//function delaunay

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

//CVertex* vertex is only required as argument of this function to
//use the graphic functions
void change_edge(CVertex* vertex,CEdge* ref){
  CEdge* next     = ref->hln;
  CEdge* diagonal = ref->fln;
  CEdge* refopp   = diagonal->oppneighbor(ref );
  CEdge* nextopp  = diagonal->oppneighbor(next);
  #ifdef GRAPHIC
  plot_edge_color(vertex,*diagonal,YELLOW);
  #endif
  diagonal->foot  = refopp->oppend(ref->foot);
  diagonal->head  = ref->head;
  diagonal->left  = next->foot;
  diagonal->right = ref->foot;
  diagonal->fln   = nextopp;
  diagonal->frn   = refopp;
  diagonal->hln   = next;
  diagonal->hrn   = ref;
  diagonal->status= INTERN;
  #ifdef GRAPHIC
  plot_edge_color(vertex,*diagonal,BLACK);
  #endif

  ref->left = refopp->oppend(ref->foot);
  ref->fln  = refopp;
  ref->hln  = diagonal;

  refopp->relright(ref->foot) = ref->head;
  refopp->relfrn(ref->foot)   = ref;
  refopp->relhrn(ref->foot)   = diagonal;

  next->right = nextopp->oppend(next->foot);
  next->frn   = nextopp;
  next->hrn   = diagonal;

  nextopp->relleft(next->foot) = next->head;
  nextopp->relfln(next->foot)  = next;
  nextopp->relhln(next->foot)  = diagonal;

  #ifdef DEBUG
  cout<<"edge is changed !"<<endl<<endl;
  #endif
}//function change_edge

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

CEdge* triangulate(CVertex* vertex, int vnum, int &ednum){
  CEdge *edge;
  edge = (CEdge*) malloc(sizeof(CEdge)*5*vnum);
  int ecounter; // counts the number of generated edges
  // 4*vnum is considered as upper bound for the number of edges, which
  //has worked in all cases we have tested. (It is not theoretically justified
  //but only by our experience up to now !)
  //The array is resized at the end of the function
  //to avoid memory waste.

  //initialization of the edge array
  //the boundary is so orientated, that the interior of the convex
  //hull is always to the left hand side
  K2 u,v;
  u = vertex[1] - vertex[0];
  v = vertex[2] - vertex[0];

  if( sgn(Det(u,v)) < 0){
    #ifdef DEBUG
    cout<<"The numeration of the vertices is NOT conform to the boundary orientation."<<endl;
    #endif
    edge[0].foot  = 1; edge[0].head  = 0; edge[0].status =EXTERN;
    edge[0].left  = 2; edge[0].right =-1;
    edge[1].foot  = 0; edge[1].head  = 2; edge[1].status =EXTERN;
    edge[1].left  = 1; edge[1].right =-1;
    edge[2].foot  = 2; edge[2].head  = 1; edge[2].status =EXTERN;
    edge[2].left  = 0; edge[2].right =-1;
  }
  else if( sgn(Det(u,v)) > 0){
    #ifdef DEBUG
    cout<<"The numeration of the vertices is conform to the boundary orientation."<<endl;
    #endif
    edge[0].foot  = 0; edge[0].head  = 1; edge[0].status =EXTERN;
    edge[0].left  = 2; edge[0].right =-1;
    edge[1].foot  = 1; edge[1].head  = 2; edge[1].status =EXTERN;
    edge[1].left  = 0; edge[1].right =-1;
    edge[2].foot  = 2; edge[2].head  = 0; edge[2].status =EXTERN;
    edge[2].left  = 1; edge[2].right =-1;
  }
  else{cerr<<"The vertices 0,1,2 lie on the same straight line"<<endl; exit(1);}

  edge[0].fln = &edge[2]; edge[0].hln = &edge[1];
  edge[1].fln = &edge[0]; edge[1].hln = &edge[2];
  edge[2].fln = &edge[1]; edge[2].hln = &edge[0];
  edge[0].frn = &edge[2]; edge[0].hrn = &edge[1];
  edge[1].frn = &edge[0]; edge[1].hrn = &edge[2];
  edge[2].frn = &edge[1]; edge[2].hrn = &edge[0];
  ecounter = 3;

  #ifdef GRAPHIC
  plot_edges(vertex,vnum,edge,ecounter,FALSE);
  plot_vertexnumber(vertex,0);
  plot_vertexnumber(vertex,1);
  plot_vertexnumber(vertex,2);
  #endif GRAPHIC

  //initialization of the circular list of boundary lines / edges
  DListElement<CEdge*> *first;
  DListElement<CEdge*> *current;
  DListElement<CEdge*> *temporary;

  first  = new DListElement<CEdge*>;
  current=first;
  current->edgep = &edge[0];

  current->next = new DListElement<CEdge*>;
  temporary = current;
  current = current->next;
  current->previous = temporary;
  current->edgep = &edge[1];

  current->next = new DListElement<CEdge*>;
  temporary = current;
  current = current->next;
  current->previous = temporary;
  current->edgep = &edge[2];

  current->next = first;
  first->previous = current;

  #ifdef DEBUG
  cout << "enter now the loop ..." <<endl;
  #endif


  //loop for adding the rest of the points to the triangulation
  for(int i=3; i<vnum; i++){
    #ifdef DEBUG
    cout << "loop i = "<< i << endl<< endl;
    #endif DEBUG
    int startindex,stopindex;
    DListElement<CEdge*>  *end;
    DListElement<CEdge*>  *start;
    DListElement<CEdge*>  *stop;
    DListElement<CEdge*>  *tmp;
    DListElement<CEdge*>  *new1 = new DListElement<CEdge*>;
    DListElement<CEdge*>  *new2 = new DListElement<CEdge*>;

    findExtremeVertices(vertex, vertex[i], current, start, stop);
    #ifdef DEBUG
    char c;
    float x,y;
    plot_vertexnumber(vertex,i);
    cout <<"start     "<< *(start->edgep);
    cout <<"stop      "<< *(stop ->edgep) << endl;
    cout <<"change start and stop ?"<<endl;
    do{ c=Getxyc(x,y);}while(c!='n' && c!='y');
    if(c=='y'){ tmp=start; start=stop; stop=tmp; }
    #endif

    //construction of the first new edge
    startindex = ecounter;
    edge[ecounter].foot   = start->edgep->foot;
    edge[ecounter].head   = i;
    edge[ecounter].left   = start->edgep->head;
    edge[ecounter].right  = -1;
    edge[ecounter].status = EXTERN;
    edge[ecounter].fln    = start->edgep;
    edge[ecounter].frn    = start->previous->edgep;
    start->edgep->frn     = &edge[ecounter];
    start->previous->edgep->hrn = &edge[ecounter];
    #ifdef GRAPHIC
    plot_edge(vertex, edge, ecounter);
    rattente(1000);
    #endif
    ecounter++;

    //construction of the remaining new edges by a loop
    current = start->next;
    do{
      edge[ecounter].foot   = current->edgep->foot;
      edge[ecounter].head   = i;
      edge[ecounter].status = INTERN;
      edge[ecounter].left   = current->edgep->head;
      edge[ecounter].right  = current->previous->edgep->foot;
      edge[ecounter].fln    = current->edgep;
      edge[ecounter].frn    = current->previous->edgep;
      edge[ecounter].hrn    = &edge[ecounter-1];
      edge[ecounter-1].hln  = &edge[ecounter];
      current->edgep->frn   = &edge[ecounter];
      current->previous->edgep->hrn = &edge[ecounter];
      edge[ecounter].frn->status = INTERN;
      edge[ecounter].frn->right  = i;
      #ifdef GRAPHIC
      plot_edge(vertex, edge, ecounter);
      rattente(1000);
      #endif
      ecounter++;
      current=current->next;
    }while(current != stop->next);
    stopindex = ecounter-1;
    edge[stopindex ].hln = &edge[startindex];
    edge[startindex].hrn = &edge[stopindex];

    //Delaunay  optimization of the constructed triangles
    #ifdef DELAUNAY
    CEdge* ref;
    ref = &edge[startindex];
    do{
      if(delaunay(vertex, ref)==FALSE) change_edge(vertex,ref);
      else ref = ref->hln;
    }while(ref != &edge[stopindex]);
    #endif

    //correction of the parameters of the last edge
    edge[stopindex ].status = EXTERN;
    edge[stopindex ].reverse();
    edge[stopindex ].right  = -1;

    //updating the circular list representing the boundary
    //insertion of the two new boundary elements
    new1->edgep = &edge[startindex];
    new2->edgep = &edge[stopindex ];
    start->previous->next = new1;
    new1->previous = start->previous;
    new1->next = new2;
    new2->previous = new1;
    new2->next = stop;
    end = stop->previous;
    stop->previous = new2;

    //cutting out old boundary edges which pertain
    //no longer to the boundary
    start->previous = NULL;             //not necessary
    end->next = NULL;
    //deleting them
    current = start;
    do{
      //current->edgep->status = INTERN;
      temporary = current;
      current = current->next;
      delete temporary;
    }while(current != NULL);

    #ifdef DEBUG
    cout << "momentary number of edges: = " << ecounter<< endl;
    cout << "existing edges :" << endl;
    for(int j=0; j<  ecounter; j++)
      cout << edge[j];
    cout << endl;
    #endif

    #ifdef DEBUG
    current = stop;
    cout << "current boundary edges:" << endl;
    temporary = current;
    do{
      cout << *(current->edgep);
      current = current->next;
    }while(current != temporary);
    cout << endl << endl;
    #endif

    current = stop;
    if(ecounter > 4*vnum){
      cerr<<"Error: There wasn't allocated enough memory for edge-array!"<<endl;
      exit(1);
    }
  }// for

  ednum = ecounter;
  edge = (CEdge*) realloc(edge, sizeof(CEdge)*ednum);
  return edge;
}// function triangulate

////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////

//This function counts for each vertex the number of edges to which
//it belongs. The result is saved in the data-member "ne" of class
//CVertex. (ne = number of edges)
//Furthermore the adresses of these edges are saved in the array "e"
//(e for edges) of type CEdge*.

void assign_edges_to_vertices(CVertex* &vertex,int vnum,CEdge* &edge,int ednum){
 //initialisation to use later realloc
 for(int i=0; i<vnum; i++){
    vertex[i].e  = (CEdge**) calloc(sizeof(CEdge*), 1);
    vertex[i].ne = 0;
  }

  for(int i=0; i<ednum; i++){
    //initialisation for select_edges
    edge[i].bflag = FALSE;
    edge[i].cflag = -1;

    vertex[edge[i].foot].e = (CEdge**) realloc(vertex[edge[i].foot].e,sizeof(CEdge*)*(vertex[edge[i].foot].ne + 1));
    vertex[edge[i].foot].e[vertex[edge[i].foot].ne] = &edge[i];
    vertex[edge[i].foot].ne++;

    vertex[edge[i].head].e = (CEdge**) realloc(vertex[edge[i].head].e,sizeof(CEdge*)*(vertex[edge[i].head].ne + 1));
    vertex[edge[i].head].e[vertex[edge[i].head].ne] = &edge[i];
    vertex[edge[i].head].ne++;
  }
} //assign_edges_to_vertices

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

// This function is based on the fact that every triangle can be assigned in a unique way to
// one of its edges. We will associate to each triangle the edge, whose vertices have the
// lowest index-number in the vertex-array. Note that this mapping is not forcibly
// surjective, so there might be two triangles, which are mapped to the same edge; but this
// doesn't matter for counting the trinagles !

CTriangle* ascertain_triangles(CVertex* vertex,int vnum,CEdge *edge,int ednum,CBoundary *bound,int bnum){
  CTriangle* triangle;
  int tcounter = 0; //counts regeistered triangles
  int en = 0; //number of edges belonging to the domain, note ednum >= en !
  int tn = 0; //number of triangles belonging to the domain, note tnum >= tn !

  //memory allocation of triangle array:
  //calculating upper bound for number of triangles by means of Euler's formula
  int tnum = ednum - vnum + 1; //number of tringles of the convex hull
  triangle = (CTriangle*) malloc(sizeof(CTriangle) * tnum);

  for(int i=0; i< ednum; i++){
    //the following if is responsible to take into account only
    //edges which belong to the domain i.e. which belong either to
    //a boundary (bflag==TRUE,cflag>0) or which lie to the left hand side
    //of the outer boundary and to the right hand side of every
    //inner boundary confining one of the holes (bflag==FALSE,cflag==0).
    //We suppose of course that all polygons are boundaries !
    //There is no polygon inside another one except that all
    //polygons representing an interior boundary are surrounded by
    //the single polygon which corresponds to the outer boundary.
    if(edge[i].bflag==TRUE && edge[i].cflag==0){
      if(edge[i].foot < edge[i].left && edge[i].head < edge[i].left){
        triangle[tcounter].v[0] =  min(edge[i].foot, edge[i].head);
        triangle[tcounter].v[1] =  max(edge[i].foot, edge[i].head);
        triangle[tcounter].v[2] =  edge[i].left;

        tcounter++;
      }
      en++;
    }
    else if(edge[i].bflag==FALSE && edge[i].cflag==0){
      if(edge[i].foot < edge[i].left && edge[i].head < edge[i].left){
        triangle[tcounter].v[0] =  min(edge[i].foot, edge[i].head);
        triangle[tcounter].v[1] =  max(edge[i].foot, edge[i].head);
        triangle[tcounter].v[2] =  edge[i].left;
        tcounter++;
      }
      if(edge[i].foot < edge[i].right && edge[i].head < edge[i].right){
        triangle[tcounter].v[0] =  min(edge[i].foot, edge[i].head);
        triangle[tcounter].v[1] =  max(edge[i].foot, edge[i].head);
        triangle[tcounter].v[2] =  edge[i].right;
        tcounter++;
      }
      en++;
    }
    else if(edge[i].bflag==TRUE && edge[i].cflag >0){
      if(edge[i].foot < edge[i].right && edge[i].head < edge[i].right){
        triangle[tcounter].v[0] =  min(edge[i].foot, edge[i].head);
        triangle[tcounter].v[1] =  max(edge[i].foot, edge[i].head);
        triangle[tcounter].v[2] =  edge[i].right;
        tcounter++;
      }
      en++;
    }
  }//for

  tn = en - vnum +2 - bnum;
  for(int i=0; i<tn; i++){
    for(int j=0; j<3; j++)
      cout<<triangle[i].v[j]<<"  ";
    cout<<endl;
  }


  triangle = (CTriangle*) realloc(triangle,sizeof(CTriangle)*tn);
  cout<<endl;
  for(int i=0; i<tn; i++){
    for(int j=0; j<3; j++)
      cout<<triangle[i].v[j]<<"  ";
    cout<<endl;
  }


  #ifdef DEBUG
  cout<<"\nAccording to Euler's formula the triangulation comprises "<<tn <<" triangles."<<endl;
  cout<<"There are "<<tcounter<<" triangles counted." <<endl;
  #endif

  //The program saves automatically the information of the triangulation in
  //the file mesh.dat which is intended for further use in FEM programs.
  ofstream fout("mesh.dat",ios::out);
  ofstream fileout("mesh.dat",ios::app);
  fout.setf(ios::right | ios::showpos | ios::fixed); fout.precision(4);

  //The first three integers correspond in this order to the number of
  //vertices triangles (tn) and boundary edges (segments).
  fout <<"   "<< vnum << "   " << tn << "   ";
  if(bnum>0) fout << bound[bnum-1].last + 1 << endl; //printing total number of boundary edges
  else fout<< 0 << endl;
  //printing coordinates of vertices
  for(int i=0; i<vnum; i++){
    fout.width(15);
    fout << vertex[i][1];
    fout.width(15);
    fout << vertex[i][2];
    fout.width(10);
    fout<< vertex[i].bflag <<endl;
  }
  //printing triangles i.e. indices of the three vertices
  fout.unsetf(ios::showpos);
  for(int i=0; i<tn; i++){
    for(int j=0; j<3; j++)
      fileout<<setw(10)<<triangle[i].v[j]<<"  "<<flush;
    fileout<<endl;
    /*fout.width(10);
    fout<< triangle[i].v[0];
    fout.width(10);
    fout<< triangle[i].v[1];
    fout.width(10);
    fout<< triangle[i].v[2]<< endl;*/
    //fout<<triangle[i];
    //cout<<triangle[i];
  }
  //printing boundary edges i.e. indices of the two vertices and cflag
  for(int i=0; i<ednum; i++){
    if(edge[i].bflag == TRUE){
      fileout.width(10);
      fileout<<edge[i].foot;
      fileout.width(10);
      fileout<<edge[i].head;
      fileout.width(5);
      fileout<<edge[i].cflag<<endl;
    }
  }
  return triangle;
}// function ascertain_triangles

///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
